package jp.kirikiri.tvp2.env;

import java.io.File;
import java.util.ArrayList;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;

import jp.kirikiri.tjs2.Interface;
import jp.kirikiri.tjs2.Dispatch2;
import jp.kirikiri.tjs2.TJSException;
import jp.kirikiri.tjs2.Variant;
import jp.kirikiri.tvp2.TVP;

public class FileSelector {

	public static boolean selectFile( Dispatch2 params ) throws TJSException {
		Variant val = new Variant();

		JFileChooser filechooser = new JFileChooser();

		int hr;
		hr = params.propGet(Interface.MEMBERMUSTEXIST, "filter", val, params );
		if( hr >= 0 ) {
			ArrayList<String> filtterlist = new ArrayList<String>();
			if( val.isObject() != true ) {
				filtterlist.add( val.asString() );
			} else {
				Dispatch2 array = val.asObject();
				int count;
				Variant tmp = new Variant();
				hr = array.propGet( Interface.MEMBERMUSTEXIST, "count", tmp, array );
				if( hr >= 0 )
					count = tmp.asInteger();
				else
					count = 0;

				for( int i = 0; i < count; i++ ) {
					hr = array.propGetByNum( Interface.MEMBERMUSTEXIST, i, tmp, array );
					if( hr >= 0 ) {
						filtterlist.add( tmp.asString() );
					}
				}
			}
			final int count = filtterlist.size();
			StringBuilder builder = new StringBuilder(512); // description
			ArrayList<String> extlist = new ArrayList<String>();
			for( int i = 0; i < count; i++ ) {
				String fileter = filtterlist.get(i);
				String[] desc = fileter.split("|");
				if( desc.length >= 2 ) {
					builder.append(desc[0]);
					String[] ext = desc[1].split(";");
					final int extcount = ext.length;
					for( int j = 0; j < extcount; j++ ) {
						int last = ext[j].lastIndexOf('.');
						if( last != -1 ) {
							String e = ext[j].substring(last);
							if( e.indexOf('*') == -1 ) {
								extlist.add(e);
							}
						}
					}
				}
			}
			if( extlist.size() > 0 ) {
				FileNameExtensionFilter filefilter = new FileNameExtensionFilter(builder.toString(),(String[]) extlist.toArray());
				filechooser.setFileFilter(filefilter);
			}
			builder = null;
			filtterlist = null;
			extlist = null;
		}
		/*
		int filterIndex = 0;
		hr = params.propGet(Interface.MEMBERMUSTEXIST, "filterIndex", val, params );
		if( hr >= 0 ) {
			filterIndex = val.asInteger();
		}
		*/

		String filename;
		hr = params.propGet(Interface.MEMBERMUSTEXIST, "name", val, params );
		if( hr >= 0 ) {
			String lname = val.asString();
			if( lname != null && lname.length() != 0 ) {
				lname = TVP.StorageMediaManager.normalizeStorageName(lname,null);
				filename = TVP.StorageMediaManager.getLocalName(lname);
				filechooser.setSelectedFile( new File(filename) );
			}
		}

		hr = params.propGet(Interface.MEMBERMUSTEXIST, "initialDir", val, params );
		if( hr >= 0 ) {
			String lname = val.asString();
			if( lname != null && lname.length() != 0 ) {
				lname = TVP.StorageMediaManager.normalizeStorageName(lname,null);
				String initDir = TVP.StorageMediaManager.getLocalName(lname);
				filechooser.setCurrentDirectory( new File(initDir) );
			}
		}

		hr = params.propGet(Interface.MEMBERMUSTEXIST, "initialDir", val, params );
		if( hr >= 0 ) {
			String title = val.asString();
			filechooser.setDialogTitle(title);
		}
		boolean issave = false;
		hr = params.propGet(Interface.MEMBERMUSTEXIST, "save", val, params );
		if( hr >= 0 ) {
			issave = val.asBoolean();
		}
		/*
		hr = params.propGet(Interface.MEMBERMUSTEXIST, "defaultExt", val, params );
		if( hr >= 0 ) {
			String ext = val.asString();
		}
		*/


		int selected;
		if( issave ) {
			selected = filechooser.showSaveDialog(null);
		} else {
			selected = filechooser.showOpenDialog(null);
		}
		if( selected == JFileChooser.APPROVE_OPTION ) {
			File file = filechooser.getSelectedFile();

			// file name
			filename = TVP.StorageMediaManager.normalizeStorageName( file.getAbsolutePath(), null );
			val.set(filename);
			params.propSet( Interface.MEMBERENSURE, "name", val, params);
			return true;
		}
		return false;
	}
}
